<template>
  <ui-button @click="toggleLoading">Toggle loading overlay</ui-button>
  <ui-transition-fade>
    <ui-loading
      :is-active="isActive"
      label="Loading, please wait!"
      :steps="loadingSteps"
      overlay
      with-scroll-lock
      lg
      @click="toggleLoading"
    />
  </ui-transition-fade>
</template>

<script lang="ts" setup>
import { ref } from 'vue'
import { useIntervalFn } from '@vueuse/core'
import { LoadingStep } from '@/propInterfaces'
import { LoadingStepStatus } from '@/enums'
import { Optional } from '@/types'

const isActive = ref(false)
const loadingSteps = ref<Optional<LoadingStep, 'id'>[]>([])

const steps = [
  'Fetching episodes',
  'Determining latest valid episode',
  'Fetching form states',
  'Merging episode forms with Journey forms',
  'Removing completed forms',
]

const { pause, resume } = useIntervalFn(
  () => {
    const index = loadingSteps.value.length - 1

    if (index >= 0) {
      loadingSteps.value[index].status = LoadingStepStatus.Done
    }

    if (steps[index + 1]) {
      loadingSteps.value.push({
        label: steps[index + 1],
        status: LoadingStepStatus.Running,
      })
    } else {
      toggleLoading()
    }
  },
  1000,
  { immediate: false },
)

const toggleLoading = () => {
  isActive.value = !isActive.value

  if (!isActive.value) {
    return pause()
  }

  loadingSteps.value = [
    {
      label: steps[0],
      status: LoadingStepStatus.Running,
    },
  ]

  resume()
}
</script>
